#!/usr/bin/perl

$mailprog = '/usr/sbin/sendmail';
use Net::POP3;

require     '/voller/pfad/zu/pop3chk.cfg';

$pop3 = Net::POP3->new($rechner);

$nachr_max = $pop3->login($name,$kennwort);


### Hauptschleife fuer alle Nachrichten des aktuellen Postfaches ###

for ($nachr_nr=1 ; $nachr_nr <= $nachr_max ; $nachr_nr++) {

    $suchwort_gefunden = 0;

    ### Erst Nachr.kopf laden zur Unterscheidung ob Muell oder Nutzinfo ###

    $kopf = $pop3->top($nachr_nr);
    $kopfzeilen_max = $#$kopf;
    for ($kopfzeile = 0 ; $kopfzeile < $kopfzeilen_max ; $kopfzeile++) {
        if ($$kopf[$kopfzeile] =~ /$suchwort/) {
            $suchwort_gefunden = 1;
        }
    }

    ### Suchkriterium erfuellt? - Nachricht weiterleiten ###

    if ($suchwort_gefunden eq 1) {

        ### Gesamte Nachricht, Kopf und Rumpf, laden mit get() ###

        $nachricht = $pop3->get($nachr_nr);
        $nachrzeilen_max = $#$nachricht;

        for ($nachrzeile = 0 ; $nachrzeile < $nachrzeilen_max ; $nachrzeile++) {

            ### Erste Leerzeile ist Abgrenzung Kopf / Rumpf - Abbruch ###

            if ($$nachricht[$nachrzeile] =~ /^$/) {
                last;
            }

            ### Altes To-Feld durch neues austauschen zur Weiterleitung ###

            if ($$nachricht[$nachrzeile] =~ /^To:/) {
                $$nachricht[$nachrzeile] = "$to_neu\n";
            }
        }

        ### Nachricht mit geaendertem Kopf an SMTP-Server senden ###

        open (MAIL, "|$mailprog -t") || die "Can't open $mailprog!\n";
        print MAIL @$nachricht, "\n";
        close (MAIL);
    }

    ### Nachricht weitergeleitet oder Werbemuell - freigeben zum Loeschen ###

    $pop3->delete($nachr_nr);

}

### Ende der Hauptschleife ueber alle Nachrichten - Loeschvorgang ###

$pop3->quit();

exit;
